// Gra_LoaderDlg.cpp : Implementierungsdatei
//
#define  WIN32_LEAN_AND_MEAN  
#include "stdafx.h"
#include "Gra_Loader.h"
#include "Gra_LoaderDlg.h"
#include "stdio.h"
#include "ForceLib.h"

#pragma pack(1) 

HINSTANCE mainInstance;
STARTUPINFO          SI;
PROCESS_INFORMATION  PI;

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialogfelddaten
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// Vom Klassenassistenten generierte berladungen virtueller Funktionen
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV-Untersttzung
	//}}AFX_VIRTUAL

// Implementierung
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// Keine Nachrichten-Handler
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

CGra_LoaderDlg::CGra_LoaderDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CGra_LoaderDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CGra_LoaderDlg)
	//}}AFX_DATA_INIT
	// Beachten Sie, dass LoadIcon unter Win32 keinen nachfolgenden DestroyIcon-Aufruf bentigt
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CGra_LoaderDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CGra_LoaderDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CGra_LoaderDlg, CDialog)
	//{{AFX_MSG_MAP(CGra_LoaderDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_STN_CLICKED(IDC_HOMEPAGE, OnStnClickedHomepage)
	ON_STN_CLICKED(IDC_BORD, OnStnClickedBord)
	ON_STN_CLICKED(IDC_CLOSE, OnStnClickedClose)
	ON_STN_CLICKED(IDC_BILD, OnStnClickedBild)
END_MESSAGE_MAP()


BOOL CGra_LoaderDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{	
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Symbol fr dieses Dialogfeld festlegen. Wird automatisch erledigt
	//  wenn das Hauptfenster der Anwendung kein Dialogfeld ist
	SetIcon(m_hIcon, TRUE);			// Groes Symbol verwenden
	SetIcon(m_hIcon, FALSE);		// Kleines Symbol verwenden
	
	return TRUE;  // Geben Sie TRUE zurck, auer ein Steuerelement soll den Fokus erhalten
}

void CGra_LoaderDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

void CGra_LoaderDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // Gertekontext fr Zeichnen

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Symbol in Client-Rechteck zentrieren
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Symbol zeichnen
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}
HCURSOR CGra_LoaderDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}
void CGra_LoaderDlg::OnOK() 
{	
//	CDialog::OnOK();
}
void CGra_LoaderDlg::OnClose() 
{
	CDialog::OnOK();
}

bool promptForFile( char* retFile, const char* tip, char* filter, char* title, bool save, HWND hWnd )
{
              OPENFILENAME ofn;
              memset(&ofn, 0, sizeof(OPENFILENAME));
              ofn.lStructSize = sizeof(OPENFILENAME);
              ofn.hwndOwner = hWnd;
              ofn.hInstance = mainInstance;
              ofn.nFilterIndex = 1;
              ofn.lpstrFile = retFile;
              ofn.nMaxFile = 256;
              ofn.lpstrInitialDir = tip;
              ofn.lpstrFilter = filter;
              ofn.lpstrTitle  = title;

              bool status;
              if( save )
              {
                  ofn.Flags = OFN_OVERWRITEPROMPT;
                  status =  (GetSaveFileName(&ofn)!=0);
              }
			  else
              {
                  ofn.Flags = OFN_FILEMUSTEXIST;
                  status = (GetOpenFileName(&ofn)!=0);
              }
              return status;
}
bool fileExists(const char* filename)
{
	WIN32_FIND_DATA finddata;
	HANDLE handle = FindFirstFile(filename,&finddata);
	return (handle!=INVALID_HANDLE_VALUE);
}

bool oldoglFix()
{
	char opengl[400] = "";
	char oldogl[400] = "";
	GetSystemDirectory(opengl,400);
	GetSystemDirectory(oldogl,400);

	int  len1 = strlen(opengl);
	opengl[len1]='\\';opengl[len1+1]='o';opengl[len1+2]='p';opengl[len1+3]='e';opengl[len1+4]='n';opengl[len1+5]='g';opengl[len1+6]='l';opengl[len1+7]='3';opengl[len1+8]='2';opengl[len1+9]='.';opengl[len1+10]='d';opengl[len1+11]='l';opengl[len1+12]='l';

	int  len2 = strlen(oldogl);
	oldogl[len2]='\\';oldogl[len2+1]='o';oldogl[len2+2]='l';oldogl[len2+3]='d';oldogl[len2+4]='o';oldogl[len2+5]='g';oldogl[len2+6]='l';oldogl[len2+7]='3';oldogl[len2+8]='2';oldogl[len2+9]='.';oldogl[len2+10]='d';oldogl[len2+11]='l';oldogl[len2+12]='l';

	if(!fileExists(oldogl))
	{
		if (!CopyFile(opengl, oldogl, FALSE))
			return false;
	}
	return true;	
}

bool RunTimeFix()
{
	char msvcr[400] = "loader.dll";
	char system[400] = "";
	GetSystemDirectory(system,400);
	
	int  len = strlen(system);
	system[len]='\\';
	system[len+1]='m';
	system[len+2]='s';
	system[len+3]='v';
	system[len+4]='c';
	system[len+5]='r';
	system[len+6]='7';
	system[len+7]='0';
	system[len+8]='.';
	system[len+9]='d';
	system[len+10]='l';
	system[len+11]='l';

	if(!fileExists(system))
	{
		if (!CopyFile(msvcr, system, FALSE))
			return false;
	}
	return true;	
}

bool CGra_LoaderDlg::Go()
{
	char hookEXE  [400] = "";
	char hookDLL  [400] = "";
	char CmdLine  [400] = "";
	char EXE      [400] = "";
	
	GetModuleFileName(0,hookEXE,390); 

	int  len = strlen(hookEXE);

	strcpy(hookDLL,hookEXE); 

	hookDLL[len-3]='d';
	hookDLL[len-2]='l';
	hookDLL[len-1]='l';


	if( !fileExists(hookDLL))
	{
		//m_log.AddString("nC.dll nicht gefunden..");
		return false;
	}
	if( !fileExists("loader.dll"))
	{
		//m_log.AddString("loader.dll nicht gefunden..");
		return false;
	}

	//if(fileExists("C:\\SIERRA\\Half-Life\\hl.exe"))
	//{
	//	strcpy(EXE,"C:\\SIERRA\\Half-Life\\hl.exe");
	//}
	//else
	//{
		promptForFile( EXE, NULL,"*.exe\0","*.exe auswhlen zum patchen...", false, 0);
	//}

	if(!oldoglFix())
	{
		//m_log.AddString("Fehler mit oldogl32.dll");
		return false;
	}
	if(!RunTimeFix())
	{
		//m_log.AddString("Loader.dll kann nicht geladen werden");
		return false;
	}

	ZeroMemory(&SI,sizeof(STARTUPINFO));
	ZeroMemory(&PI,sizeof(PROCESS_INFORMATION));
	SI.cb = sizeof(STARTUPINFO);
	
	if(strstr(EXE,"hl.exe")) // HL
	{
		strcpy(CmdLine," -game cstrike -dev -console");
	}
	if(strstr(EXE,"Game.exe")) // RENEGADE
	{
		strcpy(CmdLine," +connect 194.242.45.146:4848 +netplayername keinPlan");
	}
	if (!CreateProcess(EXE,CmdLine,NULL,NULL,FALSE,CREATE_SUSPENDED,NULL,NULL,&SI,&PI))
	{
		//m_log.AddString("Fehler beim ausfhren");
		return false;
	}
	if (!ForceLibrary(hookDLL,&PI))
	{
		//m_log.AddString("Fehler beim patchen");
		TerminateProcess(PI.hProcess,-1);
		return false;
	}
	//m_log.AddString("gepatcht...");

	ResumeThread(PI.hThread);
	CloseHandle(PI.hProcess);
	CloseHandle(PI.hThread);
	return true;
}
void CGra_LoaderDlg::OnStnClickedHomepage()
{
	ShellExecute(NULL,"open","http://www.cheat-network.net",NULL,NULL,SW_MAXIMIZE );
}
void CGra_LoaderDlg::OnStnClickedBord()
{
	ShellExecute(NULL,"open","http://board.cheat-network.net",NULL,NULL,SW_MAXIMIZE );
}

void CGra_LoaderDlg::OnStnClickedClose()
{
	::PostQuitMessage(0);
}

void CGra_LoaderDlg::OnStnClickedBild()
{
	if(Go())
		OnOK();
}
